# ISC API Library - Parameters API

A module to make user defined parameters accessible

# Operation

The ISC Script Runner process passes the path to the instance directory as an argument to the main script.
This module also uses this argument to determine the location of the parameters.json file.
After opening this file, it build a proxy object onto it, so the user can refer to parameters as properties, there is no need to use a getter function to access to a parameter value.

# Installation

    npm install git+https://git.in.lightware.com/products/isc/node_modules/isc-params-api.git
# Usage

    const params = require('isc-params-api');
    const net = require('net');
    
    class LgTvDriver{
        connection = null;

        constructor(){
            this.connection = new net.Socket();
            this.connection.connect(params.port, params.host, () => {
                console.log('Client connected');
                ...
            });
            ...
        }
    }
