import { ActionsDescriptor } from "./ActionsDescriptor";
import { Parameter } from "./ModuleDescriptorObject";
export type MethodCodeData = Record<string, {
    returnType: string;
    code: string;
    description: string;
}>;
export declare class MethodDescriptor {
    readonly name: string;
    readonly parameters: Parameter[];
    readonly actions: ActionsDescriptor;
    readonly description: string;
    readonly returnType: string;
    readonly factory: boolean;
    readonly orderId: number;
    constructor(name: string, parameters: Parameter[], actions: ActionsDescriptor, description: string, returnType?: string, factory?: boolean, orderId?: number);
    static getMethodsFromEntryCode(entryCode: string): MethodCodeData;
}
